<?php

namespace App\Console\Commands\Cloud;

use App\Domain\Cloud\Actions\CloudIntegrations\CheckCloudIntegrationEnabledAction;
use App\Domain\Cloud\Actions\DispatchToSync\DispatchCategoriesToSyncAction;
use App\Domain\Cloud\Actions\DispatchToSync\DispatchProductsToSyncAction;
use App\Domain\Cloud\Actions\DispatchToSync\DispatchPropertiesToSyncAction;
use App\Domain\Cloud\Actions\DispatchToSync\DispatchPropertyDirectoryValuesToSyncAction;
use Illuminate\Console\Command;

class CloudRecordProcessCommand extends Command
{
    protected $signature = 'cloud:records-process';
    protected $description = 'Add recordings to sync with Cloud';

    public function handle(
        DispatchProductsToSyncAction $productsToSyncAction,
        DispatchCategoriesToSyncAction $categoriesToSyncAction,
        DispatchPropertiesToSyncAction $dispatchPropertiesToSyncAction,
        DispatchPropertyDirectoryValuesToSyncAction $dispatchPropertyDirectoryValuesToSyncAction,
        CheckCloudIntegrationEnabledAction $checkAction,
    ): void {
        if (!$checkAction->execute()) {
            return;
        }

        $productsToSyncAction->execute();
        $categoriesToSyncAction->execute();
        $dispatchPropertiesToSyncAction->execute();
        $dispatchPropertyDirectoryValuesToSyncAction->execute();
    }
}
