<?php

namespace App\Domain\Cloud\Jobs;

use App\Domain\Cloud\Actions\CloudIntegrations\CheckCloudIntegrationEnabledAction;
use App\Domain\Cloud\Actions\Sync\SyncPropertiesAction;
use App\Domain\Offers\Models\Property;

class SyncPropertiesJob extends SyncEntityJob
{
    public function __construct(array $ids)
    {
        parent::__construct($ids);

        $this->queue = "{cloud-sync-properties}";
    }

    public function handle(
        SyncPropertiesAction $action,
        CheckCloudIntegrationEnabledAction $checkAction,
    ): void {
        if (!$checkAction->execute()) {
            return;
        }

        $properties = Property::withTrashed()
            ->whereIn('property_id', $this->ids)
            ->get();

        $action->execute($properties);
    }
}
