<?php

namespace App\Domain\Cloud\Jobs;

use App\Domain\Cloud\Actions\CloudIntegrations\CheckCloudIntegrationEnabledAction;
use App\Domain\Cloud\Actions\Sync\SyncPropertyDirectoryValuesAction;
use App\Domain\Offers\Models\PropertyDirectoryValue;

class SyncPropertyDirectoryValuesJob extends SyncEntityJob
{
    public function __construct(array $ids)
    {
        parent::__construct($ids);

        $this->queue = "{cloud-sync-property-directory-values}";
    }

    public function handle(
        SyncPropertyDirectoryValuesAction $action,
        CheckCloudIntegrationEnabledAction $checkAction,
    ): void {
        if (!$checkAction->execute()) {
            return;
        }

        $values = PropertyDirectoryValue::withTrashed()
            ->whereIn('directory_value_id', $this->ids)
            ->get();

        $action->execute($values);
    }
}
