<?php

namespace App\Domain\Cloud\Jobs\Tests\TestCases;

use Ensi\CloudApiSdk\Dto\Indexes\IndexesCategories\CategoryAction\CategoryAction;
use Ensi\CloudApiSdk\Dto\Indexes\IndexesCategories\IndexesCategoriesRequest;
use Mockery\Expectation;

class SyncCategoriesJobTestCase extends SyncEntityJobTestCase
{
    public function &shouldSendCategory(): ?CategoryAction
    {
        $action = null;
        /** @var Expectation $shouldReceive */
        $shouldReceive = $this->mockCloudApiIndexesApi()->shouldReceive('categories');
        $shouldReceive
            ->once()
            ->withArgs(function (IndexesCategoriesRequest $apiRequest) use (&$action) {
                $action = $apiRequest->actions[0] ?? null;

                return count($apiRequest->actions) == 1;
            });

        return $action;
    }

    public function neverSendCategory(): void
    {
        $this->mockCloudApiIndexesApi()->shouldNotReceive('categories');
    }
}
