<?php

namespace App\Domain\Cloud\Jobs\Tests\TestCases;

use Ensi\CloudApiSdk\Dto\Indexes\IndexesProducts\IndexesProductsRequest;
use Ensi\CloudApiSdk\Dto\Indexes\IndexesProducts\ProductAction\ProductAction;
use Mockery\Expectation;

class SyncProductsJobTestCase extends SyncEntityJobTestCase
{
    public function &shouldSendProduct(): ?ProductAction
    {
        $action = null;
        /** @var Expectation $shouldReceive */
        $shouldReceive = $this->mockCloudApiIndexesApi()->shouldReceive('products');
        $shouldReceive
            ->once()
            ->withArgs(function (IndexesProductsRequest $apiRequest) use (&$action) {
                $action = $apiRequest->actions[0] ?? null;

                return count($apiRequest->actions) == 1;
            });

        return $action;
    }

    public function neverSendProduct(): void
    {
        $this->mockCloudApiIndexesApi()->shouldNotReceive('products');
    }
}
