<?php

namespace App\Domain\Cloud\Jobs\Tests\TestCases;

use App\Domain\Offers\Models\ActualCategoryProperty;
use App\Domain\Offers\Models\Category;
use Ensi\CloudApiSdk\Dto\Indexes\IndexesProperties\IndexesPropertiesRequest;
use Ensi\CloudApiSdk\Dto\Indexes\IndexesProperties\PropertyAction\PropertyAction;
use Mockery\Expectation;

class SyncPropertiesJobTestCase extends SyncEntityJobTestCase
{
    public function &shouldSendProperty(): ?PropertyAction
    {
        $action = null;
        /** @var Expectation $shouldReceive */
        $shouldReceive = $this->mockCloudApiIndexesApi()->shouldReceive('properties');
        $shouldReceive
            ->once()
            ->withArgs(function (IndexesPropertiesRequest $apiRequest) use (&$action) {
                $action = $apiRequest->actions[0] ?? null;

                return count($apiRequest->actions) == 1;
            });

        return $action;
    }

    public function neverSendProperty(): void
    {
        $this->mockCloudApiIndexesApi()->shouldNotReceive('properties');
    }

    public function createLink(int $propertyId, bool $categoryActive = false, bool $categoryInactive = false): ActualCategoryProperty
    {
        /** @var ActualCategoryProperty $link */
        $link = ActualCategoryProperty::factory()->create(['property_id' => $propertyId]);

        if ($categoryActive || $categoryInactive) {
            Category::factory()->active($categoryActive)->create(['category_id' => $link->category_id]);
        }

        return $link;
    }
}
