<?php

namespace App\Domain\Cloud\Jobs\Tests\TestCases;

use Ensi\CloudApiSdk\Dto\Indexes\IndexesPropertyDirectoryValues\IndexesPropertyDirectoryValuesRequest;
use Ensi\CloudApiSdk\Dto\Indexes\IndexesPropertyDirectoryValues\PropertyDirectoryValueAction\PropertyDirectoryValueAction;
use Mockery\Expectation;

class SyncPropertyDirectoryValuesJobTestCase extends SyncEntityJobTestCase
{
    public function &shouldSendPropertyDirectoryValue(): ?PropertyDirectoryValueAction
    {
        $action = null;
        /** @var Expectation $shouldReceive */
        $shouldReceive = $this->mockCloudApiIndexesApi()->shouldReceive('propertyDirectoryValues');
        $shouldReceive
            ->once()
            ->withArgs(function (IndexesPropertyDirectoryValuesRequest $apiRequest) use (&$action) {
                $action = $apiRequest->actions[0] ?? null;

                return count($apiRequest->actions) == 1;
            });

        return $action;
    }

    public function neverSendPropertyDirectoryValue(): void
    {
        $this->mockCloudApiIndexesApi()->shouldNotReceive('propertyDirectoryValues');
    }
}
