<?php

namespace App\Domain\Kafka\Actions\Tests\Factories;

use App\Domain\Offers\Models\ActualCategoryProperty;
use App\Domain\Offers\Models\Property;

class PropertyLinkedFactory
{
    protected static function create(array $extra = []): Property
    {
        return Property::factory()->create(array_merge($extra, [
            'cloud_fields_updated_at' => now()->subDay(),
            'updated_at' => now()->subDay(),
        ]));
    }

    public static function createFromCategory(int $categoryId): Property
    {
        /** @var ActualCategoryProperty $link */
        $link = ActualCategoryProperty::factory()->create(['category_id' => $categoryId]);

        return static::create(['property_id' => $link->property_id]);
    }
}
