<?php

namespace App\Domain\Kafka\Messages\Listen\ModelEvent\Tests\Factories;

use App\Domain\Offers\Models\ActualCategoryProperty;
use App\Http\ApiV1\Support\Resources\BaseJsonResource;

class ActualCategoryPropertyEventMessageFactory extends ModelEventMessageFactory
{
    protected function definitionAttributes(): array
    {
        return [
            'id' => $this->faker->unique()->modelId(),

            'property_id' => $this->faker->modelId(),
            'category_id' => $this->faker->modelId(),
            'is_required' => $this->faker->boolean,
            'is_inherited' => $this->faker->boolean,
            'is_common' => $this->faker->boolean,
            'is_gluing' => $this->faker->boolean,

            'created_at' => $this->faker->date(BaseJsonResource::DATE_TIME_FORMAT),
            'updated_at' => $this->faker->date(BaseJsonResource::DATE_TIME_FORMAT),
        ];
    }

    public function forModel(ActualCategoryProperty $model): static
    {
        return $this->attributes([
            'id' => $model->actual_category_property_id,

            'property_id' => $model->property_id,
            'category_id' => $model->category_id,

            'created_at' => $model->created_at->format(self::DATE_TIME_FORMAT),
            'updated_at' => $model->updated_at->format(self::DATE_TIME_FORMAT),
        ]);
    }
}
