<?php

namespace App\Domain\Offers\Models;

use App\Domain\Offers\Models\Tests\Factories\PropertyDirectoryValueFactory;
use Carbon\CarbonInterface;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * @property int $id
 *
 * @property int $directory_value_id ID from PIM
 *
 * @property int $property_id ID property из PIM
 * @property string|null $name
 * @property string|null $code
 * @property string $value
 * @property string $type
 *
 * @property CarbonInterface|null $cloud_fields_updated_at
 * @property bool $cloud_created
 *
 * @property bool $is_migrated
 *
 * @property CarbonInterface|null $created_at
 * @property CarbonInterface|null $updated_at
 */
class PropertyDirectoryValue extends Model
{
    use SoftDeletes;

    protected $table = 'property_directory_values';

    protected $casts = [
        'directory_value_id' => 'int',
        'property_id' => 'int',
        'is_migrated' => 'bool',
        'cloud_fields_updated_at' => 'datetime',
    ];

    public static function factory(): PropertyDirectoryValueFactory
    {
        return PropertyDirectoryValueFactory::new();
    }
}
