<?php

namespace App\Domain\Offers\Observers;

use App\Domain\Offers\Actions\MarkPropertyAsUpdatedAction;
use App\Domain\Offers\Models\ActualCategoryProperty;
use Illuminate\Database\Eloquent\Builder;

class ActualCategoryPropertyObserver
{
    public function __construct(
        protected MarkPropertyAsUpdatedAction $markAction
    ) {
    }

    public function saved(ActualCategoryProperty $model): void
    {
        $this->markChildrenCloudFields($model, $model->wasRecentlyCreated || $model->wasChanged(['category_id']));
    }

    public function deleted(ActualCategoryProperty $model): void
    {
        $this->markChildrenCloudFields($model, true);
    }

    protected function markChildrenCloudFields(ActualCategoryProperty $model, bool $cloud): void
    {
        $this->markAction->execute(fn (Builder $query) => $query->where('property_id', $model->property_id), $cloud);
    }
}
