<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class () extends Migration {
    public function up(): void
    {
        Schema::table('properties', function (Blueprint $table) {
            $table->timestamp('cloud_fields_updated_at', 6)->useCurrent();
            $table->boolean('cloud_created')->default(false);
            $table->softDeletes();
        });
        Schema::table('property_directory_values', function (Blueprint $table) {
            $table->timestamp('cloud_fields_updated_at', 6)->useCurrent();
            $table->boolean('cloud_created')->default(false);
            $table->softDeletes();
        });
    }

    public function down(): void
    {
        Schema::table('properties', function (Blueprint $table) {
            $table->dropColumn('cloud_fields_updated_at');
            $table->dropColumn('cloud_created');
            $table->dropSoftDeletes();
        });
        Schema::table('property_directory_values', function (Blueprint $table) {
            $table->dropColumn('cloud_fields_updated_at');
            $table->dropColumn('cloud_created');
            $table->dropSoftDeletes();
        });
    }
};
